#!/bin/bash
# -*- mode: sh; fill-column: 75; tab-width: 8; coding: utf-8-unix -*-

. /usr/local/bin/usr_local_tput.bash

ROLE=toxcore
RCFILE=/usr/local/etc/testforge/pylint.rc

[ -n "$PREFIX" ] || PREFIX=/usr/local
[ -n "$PYVER" ] || PYVER=3
[ -n "$PYTHON_EXE_MSYS" ] || PYTHON_EXE_MSYS=$PREFIX/bin/python$PYVER.sh
[ -x "$PYTHON_EXE_MSYS" ] || exit 2

[ -f /usr/local/etc/testforge/testforge.bash ] && \
    . /usr/local/etc/testforge/testforge.bash

[ -z "$PYVER" ] && PYVER=3
P="BASE_PYTHON${PYVER}_MINOR"
[ -z "$PYTHON_MINOR" ] && PYTHON_MINOR="$(eval echo \$$P)"
[ -z "$PYTHON_MINOR" -a PYVER = 2 ] && BASE_PYTHON2_MINOR=$( python2 --version 2>&1| sed -e 's@^.* @@' -e 's@\.[0-9]*$@@' )
[ -z "$PYTHON_MINOR" -a PYVER = 3 ] && \
    BASE_PYTHON3_MINOR=$( python3 --version 2>&1| sed -e 's@^.* @@' -e 's@\.[0-9]*$@@' )

declare -a LARGS
LARGS=( --recursive y --verbose --py-version "$PYTHON_MINOR" --output-format colorized )

[ -f $RCFILE ] || exit 3

LARGS+=( --rcfile $RCFILE )
export PYTHONPATH=$PWD

#INFO python3.bash `which pylint` "${LARGS[@]}" "$@"
#/usr/local/bin/python3.sh `which pylint` "${LARGS[@]}" "$@"
exec $PYTHON_EXE_MSYS `which pylint` "${LARGS[@]}" "$@"
