#!/bin/bash
# -*- mode: sh; tab-width: 8; encoding: utf-8-unix -*-

prog=`basename $0 .bash`
PREFIX=/usr/local
ROLE=gpgkey

. /usr/local/bin/usr_local_tput.bash
. /usr/local/bin/gridfire.rc

if [[ "$*" =~ "--create" ]] ; then
    [[ "$*" =~ "--volume-type" ]] || [[ $RARGS =~ "--volume-type" ]] || RARGS="--volume-type=normal $RARGS"
    [[ "$*" =~ "--hash" ]] || [[ $RARGS =~ "--hash" ]] || RARGS="--hash=sha512 $RARGS"
    [[ "$*" =~ "--filesystem" ]] || [[ $RARGS =~ "--filesystem" ]] || RARGS="--filesystem=none $RARGS"
    [[ "$*" =~ "--size" ]] || [[ $RARGS =~ "--size" ]] || RARGS="--size=1G $RARGS"
    [[ "$*" =~ "--encryption" ]] || [[ $RARGS =~ "--encryption" ]] || RARGS="--encryption=Twofish $RARGS"
fi

# root@Ulati:# veracrypt --keyfiles='' --pim=100 --create  /tmp/a.tc
# Volume type:
#  1) Normal
#  2) Hidden
# Select [1]: 
# 
# Enter volume size (sizeK/size[M]/sizeG): 1G
# 
# Encryption Algorithm:
#  1) AES
#  2) Serpent
#  3) Twofish
#  4) Camellia
#  5) Kuznyechik
#  6) AES(Twofish)
#  7) AES(Twofish(Serpent))
#  8) Camellia(Kuznyechik)
#  9) Camellia(Serpent)
#  10) Kuznyechik(AES)
#  11) Kuznyechik(Serpent(Camellia))
#  12) Kuznyechik(Twofish)
#  13) Serpent(AES)
#  14) Serpent(Twofish(AES))
#  15) Twofish(Serpent)
# Select [1]: 1
# 
# Hash algorithm:
#  1) SHA-512
#  2) Whirlpool
#  3) SHA-256
#  4) Streebog
# Select [1]: 1
# 
# Filesystem:
#  1) None
#  2) FAT
#  3) Linux Ext2
#  4) Linux Ext3
#  5) Linux Ext4
#  6) NTFS
#  7) exFAT
#  8) Btrfs
# Select [2]: 2
# gridfire_veracrypt.sh

