from setuptools import setup
from setuptools.extension import Extension


setup(
    name='keyring-keyutils',zip_safe=False,
    version='0.1',
    author='Marcus Hüwe',
    author_email='suse-tux@gmx.de',
    description='A python-keyring backend for the kernel keyring.',
    packages=['keyring_keyutils'],
    ext_modules=[
        Extension('keyring_keyutils.raw', ['keyring_keyutils/raw.c'], libraries=['keyutils'],
                  extra_compile_args=['-Werror'])
    ],
    entry_points={
        'keyring_keyutils.backends': [
            'KeyringKeyutils/KernelKeyring = keyring_keyutils.backend:KeyutilsKeyringBackend'
        ]
    }
)
